﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
End Sub

'Reverses the order of a String
'Example:
'Dim msu As StringUtilities
'
'Dim mystring As String
'mystring = msu.reverseString("Basic4Android is Great!")
Public Sub reverseString (origString As String) As String
	origString = nativeMe.RunMethod("reverseString", Array (origString))
	Return origString
End Sub

'Converts a String To UPPERCASE
'Example:
'Dim msu As StringUtilities
'Dim mystring As String
'mystring = "Basic4Android is Great!"
'Log(msu.StringToUpperCase(mystring)
Public Sub StringToUpperCase (origString As String) As String
	origString = nativeMe.RunMethod("StringToUpperCase", Array (origString))
	Return origString
End Sub

'Converts a String To LOWERCASE
'Example:
'Dim msu As StringUtilities
'
'Dim mystring As String
'mystring = "Basic4Android is Great!"
'Log(msu.StringToLowerCase(mystring)
Public Sub StringToLowerCase (origString As String) As String
	origString = nativeMe.RunMethod("StringToLowerCase", Array (origString))
	Return origString
End Sub

'Get the length of a String
'Example:
'Dim msu As StringUtilities
'
'Dim mystring As String
'mystring = "Basic4Android is Great!"
'Log(msu.stringLength(mystring)
Public Sub stringLength (origString As String) As Int
    Dim strlen As Int
	strlen = nativeMe.RunMethod("stringLength", Array (origString))
	Return strlen
End Sub

#If JAVA

import java.text.ParseException;

import java.lang.String;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;


  public String reverseString (String stringToReverse) {
    String strOriginal;
    strOriginal = stringToReverse;
    strOriginal = new StringBuffer(strOriginal).reverse().toString();
    return strOriginal;
  }


public String StringToUpperCase(String inputString) {
  String outputString = inputString.toUpperCase();
  return outputString;
}


public String StringToLowerCase(String inputString) {
  String outputString = inputString.toLowerCase();
  return outputString;
}


public int stringLength(String inputString) {
  int stringlength = inputString.length();
  return stringlength;
}


/**
* Replace all occurances of a char in a string with a new char
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mystring As String
*mystring = "Basic4Android is Great!"
*log(msu.replaceChar(mystring,"A","B")
*</code>
*/
public String replaceChar(String inputString, char oldChar, char newChar) {
  String outputString = inputString.replace(oldChar, newChar);
  return outputString; 

}


/**
*Replaces only the first occurances of a given String with a new one
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mystring As String
*mystring = "Replace Region"
*log(msu.replaceFirstOccur(mystring,"Re","Ra")
*</code>
*/
public String replaceFirstOccur(String inputString, String oldString, String newString) {
  String outputString = inputString.replaceFirst(oldString, newString);
  return outputString; 

}


/**
*Replace all occurances of a given String with a new one
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mystring As String
*mystring = "Replace Region"
*log(msu.replaceAllOccur(mystring,"Re","Ra")
*</code>
*/
public String replaceAllOccur(String inputString, String oldString, String newString) {
  String outputString = inputString.replaceAll(oldString, newString);
  return outputString; 

}


/**
*This method returns true/false if the input string contains a given substring.
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mystring as String
*mystring = "Replace Region"
*log(msu.containString(mystring,"Re")
*</code>
*/
public boolean containString(String inputString, String substring) {
  boolean containstring = inputString.contains(substring);
  return containstring; 

}


/**
*Removes the leading and trailing spaces from a string
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mystring as String
*mystring = "    Replace Region    "
*log(msu.Trim(mystring)
*</code>
*/
public String Trim(String inputString) {
  String strTrimmed = inputString.trim();
  return strTrimmed;

}


/**
*This method returns true/false when the input string starts with the substring
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mystring as String
*mystring = "Replace Region"
*log(msu.StringStartsWith(mystring,"Replace")
*</code>
*/
public boolean stringStartsWith(String inputString, String substring) {
  boolean startWithString = inputString.startsWith(substring);
  return startWithString; 

}


/**
*Sorts an array of strings in decending order
*It is case SENSITIVE. Therefore A-Z takes preference over a-z
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mywords() As String
*mywords = Array As String("My", "name", "is", "Johan", "Schoeman")
*mywords = msu.sortStringCaseSensitive(mywords)
*For i = 0 To mywords.Length-1
*  Log(mywords(i))
*Next
*</code>
*/
public String[] sortStringCaseSensitive(String[] strNames) {
  Arrays.sort(strNames);
  return strNames;

}


/**
*Sorts an array of strings in decending order
*It is case INSENSITIVE. Therefore b will for eg take preference over Z
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mywords() As String
*mywords = Array As String("My", "name", "is", "Johan", "Schoeman")
*mywords = msu.sortStringCaseInSensitive(mywords)
*For i = 0 To mywords.Length-1
*  Log(mywords(i))
*Next
*</code>
*/
public String[] sortStringCaseInSensitive(String[] strNames) {
  Arrays.sort(strNames, String.CASE_INSENSITIVE_ORDER);
  return strNames;

}


/**
*Sorts an array of strings in decending order
*It is case SENSITIVE
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mywords() As String
*mywords = Array As String("a", "B", "c", "D", "z")
*mywords = msu.sortStringArrayDecendingCaseSensitive(mywords)
*For i = 0 To mywords.Length-1
*  Log(mywords(i))
*Next
*</code>
*
*Return array will be (starting from index 0) z, c, a, D, B
*/
public String[] sortStringArrayDecendingCaseSensitive(String[] strNames) {
  Arrays.sort(strNames, Collections.reverseOrder());
  return strNames;

}



/**
*Sorts an array of strings in ascending order
*It is case SENSITIVE
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mywords() As String
*mywords = Array As String("a", "B", "c", "D", "z")
*mywords = msu.sortStringArrayDecendingCaseSensitive(mywords)
*For i = 0 To mywords.Length-1
*  Log(mywords(i))
*Next
*</code>
*
*Return array will be (starting from index 0) z, D, c, B, a
*/
public String[] sortStringArrayDecendingCaseInSensitive(String[] strNames) {
  Arrays.sort(strNames, String.CASE_INSENSITIVE_ORDER);
  String[] newStrNames = new String[strNames.length];
 
  for (int arrayIterator = 0; arrayIterator < strNames.length; arrayIterator++) { 
    newStrNames[arrayIterator] = strNames[strNames.length - 1 - arrayIterator];
  } 

  return newStrNames;

}


/**
*Returns a substring of the string starting from index
*
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mystring As String
*Dim myindex as Int = 6
*mystring = "Hello World"
*Log(msu.subString1(mystring,myindex))
*</code>
*Returned substring = World
*/
public String subString1(String myString, int myIndex) {
  myString = myString.substring(myIndex);
  return myString;

}


/**
*Returns a substring of the string starting from fromIndex upto toIndex-1
*Here fromIndex is inclusive while toIndex is exclusive.
*Example:<code>
*Dim msu As B4AstringUtils
*
*Dim mystring As String
*Dim fromIndex as Int = 0
*Dim toIndex as Int = 5
*mystring = "Hello World"
*Log(msu.subString2(mystring, fromIndex, toIndex))
*</code>
*Returned substring = Hello
*/
public String subString2(String myString, int fromIndex, int toIndex) {
  myString = myString.substring(fromIndex,toIndex);
  return myString;

}

#End If